<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'agency',
	'database_column_primary_key' => 'agency_id',

	//Menu
	'url_slug' => 'agencies',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Agency', $this->shared->get('text_domain')),
	'label_plural' => __('Agencies', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Agency', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Agency', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Agency', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Agency', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The agency has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The agency has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The agency has been successfully updated.', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'agency_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the Agency.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'name',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the agency.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'description',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the agency.', $this->shared->get('text_domain')),
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'name',
			'query_placeholder_token' => 's',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the agency.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => esc_attr__('Please enter a valid value in the "Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'description',
			'query_placeholder_token' => 's',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the agency.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => esc_attr__('Please enter a valid value in the "Description" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'full_name',
			'query_placeholder_token' => 's',
			'label' => __('Full Name', $this->shared->get('text_domain')),
			'tooltip' => __('The full name of the agency.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Full Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'address',
			'query_placeholder_token' => 's',
			'label' => __('Address', $this->shared->get('text_domain')),
			'tooltip' => __('The address of the agency.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Address" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'tel',
			'query_placeholder_token' => 's',
			'label' => __('Telephone Number', $this->shared->get('text_domain')),
			'tooltip' => __('The telephone number of the agency.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Telephone" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'fax',
			'query_placeholder_token' => 's',
			'label' => __('Fax Number', $this->shared->get('text_domain')),
			'tooltip' => __('The fax number of the agency.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Fax" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'website',
			'query_placeholder_token' => 's',
			'label' => __('Website', $this->shared->get('text_domain')),
			'tooltip' => __('The website of the agency.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '2083',
			'validation_function' => [
				[
					'function' => 'validate_url',
					'message' => esc_attr__('Please enter a valid value in the "Website" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
	],
);
$menu->generate_menu();