<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'agency_contract',
	'database_column_primary_key' => 'agency_contract_id',

	//Menu
	'url_slug' => 'agency-contracts',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Agency Contract', $this->shared->get('text_domain')),
	'label_plural' => __('Agency Contracts', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Agency Contract', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Agency Contract', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Agency Contract', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Agency Contract', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The contract has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The contract has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The contract has been successfully updated.', $this->shared->get('text_domain')),
	'custom_validation' => 'menu_agency_contracts_custom_validation',

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'agency_contract_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the contract.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'player_id',
			'label' => __('Player', $this->shared->get('text_domain')),
			'tooltip' => __('The player.', $this->shared->get('text_domain')),
			'filter' => 'get_player_name'
		],
		[
			'database_column' => 'agency_id',
			'label' => __('Agency', $this->shared->get('text_domain')),
			'tooltip' => __('The agency of the player.', $this->shared->get('text_domain')),
			'filter' => 'get_agency_name'
		],
		[
			'database_column' => 'agency_contract_type_id',
			'label' => __('Agency Contract Type', $this->shared->get('text_domain')),
			'tooltip' => __('The contract type.', $this->shared->get('text_domain')),
			'filter' => 'get_agency_contract_type_name'
		],
		[
			'database_column' => 'start_date',
			'label' => __('Start Date', $this->shared->get('text_domain')),
			'tooltip' => __('The start date of the contract.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
		[
			'database_column' => 'end_date',
			'label' => __('End Date', $this->shared->get('text_domain')),
			'tooltip' => __('The end date of the contract.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'player_id',
			'query_placeholder_token' => 'd',
			'label' => __('Player', $this->shared->get('text_domain')),
			'tooltip' => __('The player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_players(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'player_exists',
					'message' => esc_attr__('Please enter a valid value in the "Player" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'agency_id',
			'query_placeholder_token' => 'd',
			'label' => __('Agency', $this->shared->get('text_domain')),
			'tooltip' => __('The agency.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_agencies(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'agency_exists',
					'message' => esc_attr__('Please enter a valid value in the "Agency" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'agency_contract_type_id',
			'query_placeholder_token' => 'd',
			'label' => __('Contract Type', $this->shared->get('text_domain')),
			'tooltip' => __('The contract type.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_agency_contract_types(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'agency_contract_type_exists',
					'message' => esc_attr__('Please enter a valid value in the "Agency Contract Type" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'start_date',
			'query_placeholder_token' => 's',
			'label' => __('Start Date', $this->shared->get('text_domain')),
			'tooltip' => __('The start date of the contract.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => esc_attr__('Please enter a valid value in the "Start Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
		[
			'column' => 'end_date',
			'query_placeholder_token' => 's',
			'label' => __('End Date', $this->shared->get('text_domain')),
			'tooltip' => __('The end date of the contract.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => esc_attr__('Please enter a valid value in the "End Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $menu_utility->num_of_players() === 0,
			'code' => 'num_of_players'
		],
		[
			'status' => $menu_utility->num_of_agency_contract_types() === 0,
			'code' => 'num_of_agency_contract_types'
		],
		[
			'status' => $menu_utility->num_of_agencies() === 0,
			'code' => 'num_of_agencies'
		]
	],

);
$menu->generate_menu();