<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'competition',
	'database_column_primary_key' => 'competition_id',

	//Menu
	'url_slug' => 'competitions',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Competition', $this->shared->get('text_domain')),
	'label_plural' => __('Competitions', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create Competition', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Competition', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Competition', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Competition', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The competition has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The competition has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The competition has been successfully updated.', $this->shared->get('text_domain')),
	'custom_validation' => 'menu_competitions_custom_validation',

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'competition_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the competition.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'name',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the competition.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'type',
			'label' => __('Type', $this->shared->get('text_domain')),
			'tooltip' => __('The type of competition.', $this->shared->get('text_domain')),
			'filter' => 'get_competition_type_name'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'name',
			'query_placeholder_token' => 's',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the competition.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => __('Please enter a valid value in the "Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'description',
			'query_placeholder_token' => 's',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the competition.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => __('Please enter a valid value in the "Description" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'logo',
			'query_placeholder_token' => 's',
			'label' => __('Logo', $this->shared->get('text_domain')),
			'instructions' => __('Select a logo that represents this competition.', $this->shared->get('text_domain')),
			'set_image' => __('Set Image', $this->shared->get('text_domain')),
			'remove_image' => __('Remove Image', $this->shared->get('text_domain')),
			'type' => 'image',
			'maxlength' => '2083',
			'validation_function' => [
				[
					'function' => 'validate_url_empty_allowed',
					'message' => __('Please enter a valid value in the "Logo" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column'                  => 'rounds',
			'query_placeholder_token' => 's',
			'label'                   => __( 'Rounds', $this->shared->get('text_domain')),
			'tooltip'                 => __( 'The number of rounds of the competition.', $this->shared->get('text_domain')),
			'type'                    => 'text',
			'value'                   => '8',
			'maxlength'               => '3',
			'validation_function' => [
				[
					'function' => 'validate_rounds',
					'message' => __('Please enter a valid value in the "Rounds" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable'              => true,
		],
		[
			'column' => 'type',
			'query_placeholder_token' => 'd',
			'label' => __('Type', $this->shared->get('text_domain')),
			'tooltip' => __('The type of competition.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => [
				[
					'value' => 0,
					'text' => esc_attr__('Elimination', 'soccer-engine-lite'),
					'selected' => true
				],
				[
					'value' => 1,
					'text' => esc_attr__('Round Robin', 'soccer-engine-lite'),
					'selected' => false
				],
			],
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_bool',
					'message' => __('Please enter a valid value in the "Hidden" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
	],

);

$menu->settings['fields'][] = [
	'target' => 'teams',
	'label' => __('Teams', $this->shared->get('text_domain')),
	'type' => 'group-trigger',
];

for($i=1;$i<=128;$i++){
	$menu->settings['fields'][] = [
		'class' => 'teams',
		'column' => 'team_id_' . $i,
		'query_placeholder_token' => 'd',
		'label' => __('Team', $this->shared->get('text_domain')) . ' ' . $i,
		'tooltip' => __('The team', $this->shared->get('text_domain')) . ' ' . $i . '.',
		'type' => 'select',
		'select_items' => $menu_utility->select_teams(true),
		'validation_regex' => null,
		'maxlength' => '1',
		'validation_function' => [
			[
				'function' => 'team_exists_none_allowed',
				'message' => esc_attr__('Please enter a valid value in the "Team', $this->shared->get('text_domain')) .
				             ' ' . $i . '"', esc_attr__('field.', $this->shared->get('text_domain')),
			],
		],
		'required' => false,
		'searchable' => false,
	];
}

$menu->settings['fields'][] = [
	'target' => 'round-robin',
	'label'  => __( 'Round Robin', $this->shared->get('text_domain')),
	'type'   => 'group-trigger',
];
$menu->settings['fields'][] = [
	'class'                   => 'round-robin',
	'column'                  => 'rr_victory_points',
	'query_placeholder_token' => 's',
	'label'                   => __( 'Victory Points', $this->shared->get('text_domain')),
	'tooltip'                 => __( 'The number of points assigned to a team when a victory is achieved in a Round Robin competition.', $this->shared->get('text_domain')),
	'type'                    => 'text',
	'value'                   => '3',
	'maxlength'               => '255',
	'validation_function' => [
		[
			'function' => 'validate_tinyint_unsigned',
			'message' => __('Please enter a valid value in the "Victory Points" field.', $this->shared->get('text_domain')),
		],
	],
	'required' => true,
	'searchable'              => true,
];
$menu->settings['fields'][] = [
	'class'                   => 'round-robin',
	'column'                  => 'rr_draw_points',
	'query_placeholder_token' => 's',
	'label'                   => __( 'Draw Points', $this->shared->get('text_domain')),
	'tooltip'                 => __( 'The number of points assigned to a team when a draw is achieved in a Round Robin competition.', $this->shared->get('text_domain')),
	'type'                    => 'text',
	'value'                   => '1',
	'maxlength'               => '255',
	'validation_function' => [
		[
			'function' => 'validate_tinyint_unsigned',
			'message' => __('Please enter a valid value in the "Draw Points" field.', $this->shared->get('text_domain')),
		],
	],
	'required' => true,
	'searchable'              => true,
];
$menu->settings['fields'][] = [
	'class'                   => 'round-robin',
	'column'                  => 'rr_defeat_points',
	'query_placeholder_token' => 's',
	'label'                   => __( 'Defeat Points', $this->shared->get('text_domain')),
	'tooltip'                 => __( 'The number of points assigned to a team when a defeat is achieved in a Round Robin competition.', $this->shared->get('text_domain')),
	'type'                    => 'text',
	'value'                   => '0',
	'maxlength'               => '255',
	'validation_function' => [
		[
			'function' => 'validate_tinyint_unsigned',
			'message' => __('Please enter a valid value in the "Defeat Points" field.', $this->shared->get('text_domain')),
		],
	],
	'required' => true,
	'searchable'              => true,
];
$menu->settings['fields'][] = [
	'class'                   => 'round-robin',
	'column'                  => 'rr_sorting_order_1',
	'query_placeholder_token' => 'd',
	'label'                   => __( 'Order (Priority 1)', $this->shared->get('text_domain')),
	'tooltip'                 => __( 'This option allows you to enable (in descending or ascending order) or disable the order for the specified column.', $this->shared->get('text_domain')),
	'type'                    => 'select',
	'select_items'            => [
		[
			'value'    => 0,
			'text'     => __('Descending', 'soccer-engine-lite'),
			'selected' => true
		],
		[
			'value'    => 1,
			'text'     => __('Ascending', 'soccer-engine-lite'),
			'selected' => false
		]
	],
	'maxlength'               => '1',
	'validation_function' => [
		[
			'function' => 'validate_competition_order_type',
			'message' => __('Please enter a valid value in the "Order 1" field.', $this->shared->get('text_domain')),
		],
	],
	'searchable'              => false,
];
$rr_sorting_order_by_1 = [
	[
		'value'    => 0,
		'text'     => __('Won', 'soccer-engine-lite'),
		'selected' => false
	],
	[
		'value'    => 1,
		'text'     => __('Drawn', 'soccer-engine-lite'),
		'selected' => false
	],
	[
		'value'    => 2,
		'text'     => __('Lost', 'soccer-engine-lite'),
		'selected' => false
	],
	[
		'value'    => 3,
		'text'     => __('Goals', 'soccer-engine-lite'),
		'selected' => false
	],
	[
		'value'    => 4,
		'text'     => __('Goal Difference', 'soccer-engine-lite'),
		'selected' => false
	],
	[
		'value'    => 5,
		'text'     => __('Points', 'soccer-engine-lite'),
		'selected' => true
	],
];
$menu->settings['fields'][] = [
	'class'                   => 'round-robin',
	'column'                  => 'rr_sorting_order_by_1',
	'query_placeholder_token' => 'd',
	'label'                   => __( 'Order by (Priority 1)', $this->shared->get('text_domain')),
	'tooltip'                 => __( 'This option allows you to determine for which column the order should be applied.', $this->shared->get('text_domain')),
	'type'                    => 'select',
	'select_items'            => $rr_sorting_order_by_1,
	'maxlength'               => '1',
	'validation_function' => [
		[
			'function' => 'validate_competition_order_by',
			'message' => __('Please enter a valid value in the "Order by 1" field.', $this->shared->get('text_domain')),
		],
	],
	'searchable'              => false,
];
$menu->settings['fields'][] = [
	'class'                   => 'round-robin',
	'column'                  => 'rr_sorting_order_2',
	'query_placeholder_token' => 'd',
	'label'                   => __( 'Order (Priority 2)', $this->shared->get('text_domain')),
	'tooltip'                 => __( 'This option allows you to enable (in descending or ascending order) or disable the order for the specified column.', $this->shared->get('text_domain')),
	'type'                    => 'select',
	'select_items'            => [
		[
			'value'    => 0,
			'text'     => __('Descending', 'soccer-engine-lite'),
			'selected' => false
		],
		[
			'value'    => 1,
			'text'     => __('Ascending', 'soccer-engine-lite'),
			'selected' => false
		]
	],
	'maxlength'               => '1',
	'validation_function' => [
		[
			'function' => 'validate_competition_order_type',
			'message' => __('Please enter a valid value in the "Order 2" field.', $this->shared->get('text_domain')),
		],
	],
	'searchable'              => false,
];
$rr_sorting_order_by_2 = [
	[
		'value'    => 0,
		'text'     => __('Won', 'soccer-engine-lite'),
		'selected' => false
	],
	[
		'value'    => 1,
		'text'     => __('Drawn', 'soccer-engine-lite'),
		'selected' => false
	],
	[
		'value'    => 2,
		'text'     => __('Lost', 'soccer-engine-lite'),
		'selected' => false
	],
	[
		'value'    => 3,
		'text'     => __('Goals', 'soccer-engine-lite'),
		'selected' => false
	],
	[
		'value'    => 4,
		'text'     => __('Goal Difference', 'soccer-engine-lite'),
		'selected' => true
	],
	[
		'value'    => 5,
		'text'     => __('Points', 'soccer-engine-lite'),
		'selected' => false
	],
];
$menu->settings['fields'][] = [
	'class'                   => 'round-robin',
	'column'                  => 'rr_sorting_order_by_2',
	'query_placeholder_token' => 'd',
	'label'                   => __( 'Order by (Priority 2)', $this->shared->get('text_domain')),
	'tooltip'                 => __( 'This option allows you to determine for which column the order should be applied.', $this->shared->get('text_domain')),
	'type'                    => 'select',
	'select_items'            => $rr_sorting_order_by_2,
	'maxlength'               => '1',
	'validation_function' => [
		[
			'function' => 'validate_competition_order_by',
			'message' => __('Please enter a valid value in the "Order by 2" field.', $this->shared->get('text_domain')),
		],
	],
	'searchable'              => false,
];

$menu->generate_menu();