<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'event',
	'database_column_primary_key' => 'event_id',

	//Menu
	'url_slug' => 'events',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Event', $this->shared->get('text_domain')),
	'label_plural' => __('Events', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Event', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Event', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Event', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Event', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The event has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The event has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The event has been successfully updated.', $this->shared->get('text_domain')),
	'custom_validation' => 'menu_events_custom_validation',

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'event_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the event.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'data',
			'label' => __('Data', $this->shared->get('text_domain')),
			'tooltip' => __('The type of data associated with the event.', $this->shared->get('text_domain')),
			'filter' => 'get_data_name'
		],
		[
			'database_column' => 'match_id',
			'label' => __('Match', $this->shared->get('text_domain')),
			'tooltip' => __('The match of the event.', $this->shared->get('text_domain')),
			'filter' => 'get_match_name'
		],
		[
			'database_column' => 'team_slot',
			'label' => __('Team', $this->shared->get('text_domain')),
			'tooltip' => __('The team of the event.', $this->shared->get('text_domain')),
			'filter' => 'get_team_slot_name'
		],
		[
			'database_column' => 'match_effect',
			'label' => __('Match Effect', $this->shared->get('text_domain')),
			'tooltip' => __('The effect of the event on the match.', $this->shared->get('text_domain')),
			'filter' => 'get_match_effect_name'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'data',
			'query_placeholder_token' => 'd',
			'label' => __('Data', $this->shared->get('text_domain')),
			'tooltip' => __('The type of data associated with the event.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => [
				[
					'value' => 0,
					'text' => __('Basic', 'soccer-engine-lite'),
					'selected' => false
				],
				[
					'value' => 1,
					'text' => __('Complete', 'soccer-engine-lite'),
					'selected' => true
				]
			],
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_bool',
					'message' => __('Please enter a valid value in the "Data" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'match_id',
			'query_placeholder_token' => 'd',
			'label' => __('Match', $this->shared->get('text_domain')),
			'tooltip' => __('The match of the event.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_matches(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => $this->shared->match_exists,
					'message' => __('Please enter a valid value in the "Match" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'team_slot',
			'query_placeholder_token' => 'd',
			'label' => __('Team', $this->shared->get('text_domain')),
			'tooltip' => __('The team of the event.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => [
				[
					'value' => 0,
					'text' => __('Team 1', 'soccer-engine-lite'),
					'selected' => false
				],
				[
					'value' => 1,
					'text' => __('Team 2', 'soccer-engine-lite'),
					'selected' => false
				]
			],
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_team_slot',
					'message' => __('Please enter a valid value in the "Team" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'match_effect',
			'query_placeholder_token' => 'd',
			'label' => __('Match Effect', $this->shared->get('text_domain')),
			'tooltip' => __('The effect of the event on the match.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_match_effects(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => $this->shared->match_effect_exists,
					'message' => __('Please enter a valid value in the "Match Effect" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'player_id',
			'query_placeholder_token' => 'd',
			'label' => __('Player', $this->shared->get('text_domain')),
			'tooltip' => __('The player who caused the event.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_players(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => $this->shared->player_exists_none_allowed,
					'message' => __('Please enter a valid value in the "Player" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'player_id_substitution_out',
			'query_placeholder_token' => 'd',
			'label' => __('Player Substitution Out', $this->shared->get('text_domain')),
			'tooltip' => __('The replaced player of a substitution event.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_players(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => $this->shared->player_exists_none_allowed,
					'message' => __('Please enter a valid value in the "Player Substitution Out" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'player_id_substitution_in',
			'query_placeholder_token' => 'd',
			'label' => __('Player Substitution In', $this->shared->get('text_domain')),
			'tooltip' => __('The new player of a substitution event.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_players(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => $this->shared->player_exists_none_allowed,
					'message' => __('Please enter a valid value in the "Player Substitution In" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'staff_id',
			'query_placeholder_token' => 'd',
			'label' => __('Staff', $this->shared->get('text_domain')),
			'tooltip' => __('The staff member who caused the event.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_staff(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => $this->shared->staff_exists_none_allowed,
					'message' => __('Please enter a valid value in the "Staff" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'part',
			'query_placeholder_token' => 'd',
			'label' => __('Part', $this->shared->get('text_domain')),
			'tooltip' => __('The part of the match.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_parts(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_match_part',
					'message' => __('Please enter a valid value in the "Part" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'time',
			'query_placeholder_token' => 's',
			'label' => __('Time', $this->shared->get('text_domain')),
			'tooltip' => __('The time of the event in the selected match part.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '2',
			'value' => '1',
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'additional_time',
			'query_placeholder_token' => 's',
			'label' => __('Additional Time', $this->shared->get('text_domain')),
			'tooltip' => __('The additional time of the event in the selected match part.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '2',
			'value' => '0',
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'description',
			'query_placeholder_token' => 's',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the event.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '1000',
			'required' => true,
			'searchable' => true,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $this->shared->get_number_of_matches() === 0,
			'code' => 'number_of_matches'
		],
		[
			'status' => $menu_utility->num_of_teams() === 0,
			'code' => 'num_of_teams'
		],
	],

);
$menu->generate_menu();