<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'formation',
	'database_column_primary_key' => 'formation_id',

	//Menu
	'url_slug' => 'formations',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Formation', $this->shared->get('text_domain')),
	'label_plural' => __('Formations', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Formation', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Formation', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Formation', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Formation', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The formation has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The formation has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The formation has been successfully updated.', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'formation_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the formation.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'name',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the formation.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'description',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the formation.', $this->shared->get('text_domain')),
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'name',
			'query_placeholder_token' => 's',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the formation.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => __('Please enter a valid value in the "Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'description',
			'query_placeholder_token' => 's',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the formation.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => __('Please enter a valid value in the "Description" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
	],
);

for($i=1;$i<=11;$i++){
	$menu->settings['fields'][] = [
		'column' => 'x_position_' . $i,
		'query_placeholder_token' => 's',
		'label' => __('X Position', $this->shared->get('text_domain')) . ' ' . $i,
		'tooltip' => __('The X position of player', $this->shared->get('text_domain')) . ' ' . $i . '.',
		'type' => 'text',
		'maxlength' => '3',
		'validation_function' => [
			[
				'function' => 'validate_formation_position',
				'message' => esc_attr__('Please enter a valid value in the "X Position', $this->shared->get('text_domain')) . ' ' . $i . ' ' .
				             esc_attr__('field.', $this->shared->get('text_domain')),
			],
		],
		'value' => '1',
		'required' => true,
		'searchable' => true,
	];

	$menu->settings['fields'][] = [
		'column' => 'y_position_' . $i,
		'query_placeholder_token' => 's',
		'label' => __('Y Position ', $this->shared->get('text_domain')) . ' ' . $i,
		'tooltip' => __('The Y position of player', $this->shared->get('text_domain')) . ' ' . $i . '.',
		'type' => 'text',
		'maxlength' => '3',
		'validation_function' => [
			[
				'function' => 'validate_formation_position',
				'message' => esc_attr__('Please enter a valid value in the "Y Position', $this->shared->get('text_domain')) . ' ' . $i .
				             esc_attr__(' field.', $this->shared->get('text_domain')),
			],
		],
		'value' => '1',
		'required' => true,
		'searchable' => true,
	];

}

$menu->generate_menu();