<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'injury',
	'database_column_primary_key' => 'injury_id',

	//Menu
	'url_slug' => 'injuries',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Injury', $this->shared->get('text_domain')),
	'label_plural' => __('Injuries', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Injury', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Injury', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Injury', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Injury', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The injury has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The injury has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The injury has been successfully updated.', $this->shared->get('text_domain')),
	'custom_validation' => 'menu_injuries_custom_validation',

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'injury_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the injury.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'player_id',
			'label' => __('Player', $this->shared->get('text_domain')),
			'tooltip' => __('The injured player.', $this->shared->get('text_domain')),
			'filter' => 'get_player_name'
		],
		[
			'database_column' => 'injury_type_id',
			'label' => __('Injury Type', $this->shared->get('text_domain')),
			'tooltip' => __('The injury type.', $this->shared->get('text_domain')),
			'filter' => 'get_injury_type_name'
		],
		[
			'database_column' => 'start_date',
			'label' => __('Start Date', $this->shared->get('text_domain')),
			'tooltip' => __('The start date.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
		[
			'database_column' => 'end_date',
			'label' => __('End Date', $this->shared->get('text_domain')),
			'tooltip' => __('The end date.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'player_id',
			'query_placeholder_token' => 'd',
			'label' => __('Player', $this->shared->get('text_domain')),
			'tooltip' => __('The injured player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_players(),
			'validation_regex' => null,
			'maxlength' => '1',
			[
				'function' => 'player_exists',
				'message' => __('Please enter a valid value in the "Player" field.', $this->shared->get('text_domain')),
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'injury_type_id',
			'query_placeholder_token' => 'd',
			'label' => __('Injury Type', $this->shared->get('text_domain')),
			'tooltip' => __('The injury type.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_injury_types(),
			'validation_regex' => null,
			'maxlength' => '1',
			[
				'function' => 'injury_type_exists',
				'message' => __('Please enter a valid value in the "Injury Type" field.', $this->shared->get('text_domain')),
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'start_date',
			'query_placeholder_token' => 's',
			'label' => __('Start Date', $this->shared->get('text_domain')),
			'tooltip' => __('The start date.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => esc_attr__('Please enter a valid date in the "Start Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
		[
			'column' => 'end_date',
			'query_placeholder_token' => 's',
			'label' => __('End Date', $this->shared->get('text_domain')),
			'tooltip' => __('The end date.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => esc_attr__('Please enter a valid date in the "End Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $menu_utility->num_of_injurie_types() === 0,
			'code' => 'num_of_injurie_types'
		],
		[
			'status' => $menu_utility->num_of_players() === 0,
			'code' => 'num_of_players'
		]
	],

);
$menu->generate_menu();