<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'jersey_set',
	'database_column_primary_key' => 'jersey_set_id',

	//Menu
	'url_slug' => 'jersey-sets',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Jersey Set', $this->shared->get('text_domain')),
	'label_plural' => __('Jersey Sets', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Jersey Set', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Jersey Set', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Jersey Set', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Jersey Set', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The jersey set has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The jersey set has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The jersey set has been successfully updated.', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'jersey_set_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the jersey set.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'name',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the jersey set.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'description',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the jersey set.', $this->shared->get('text_domain')),
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'name',
			'query_placeholder_token' => 's',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the jersey set.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => __('Please enter a valid value in the "Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'description',
			'query_placeholder_token' => 's',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the jersey set.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => __('Please enter a valid value in the "Description" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
	],

);

$menu->settings['fields'][] = [
	'target' => 'players',
	'label' => __('Players', $this->shared->get('text_domain')),
	'type' => 'group-trigger',
];

for($i=1;$i<=50;$i++){

	$menu->settings['fields'][] = [
		'class' => 'players',
		'column' => 'player_id_' . $i,
		'query_placeholder_token' => 'd',
		'label' => __('Player', $this->shared->get('text_domain')) . ' ' . $i,
		'tooltip' => __('The player', $this->shared->get('text_domain')) . ' ' . $i . '.',
		'type' => 'select',
		'select_items' => $menu_utility->select_players(true),
		'validation_regex' => null,
		'maxlength' => '1',
		'validation_function' => [
			[
				'function' => $this->shared->player_exists_none_allowed,
				'message' => esc_attr__('Please enter a valid value in the "Player', $this->shared->get('text_domain')) . ' ' . $i .
				             esc_attr__(' field.', $this->shared->get('text_domain')),
			],
		],
		'required' => false,
		'searchable' => false,
	];

	$menu->settings['fields'][] = [
		'class' => 'players',
		'column' => 'jersey_number_player_id_' . $i,
		'query_placeholder_token' => 'd',
		'label' => __('Jersey Number Player', $this->shared->get('text_domain')) . ' ' . $i,
		'tooltip' => __('The jersery number of player', $this->shared->get('text_domain')) . ' ' . $i . '.',
		'type' => 'text',
		'maxlength' => '3',
		'validation_function' => [
			[
				'function' => 'validate_jersey_number',
				'message' => __('Please enter a valid value in the "Jersey" field.', $this->shared->get('text_domain')),
			],
		],
		'required' => false,
		'searchable' => false,
	];

}

$menu->generate_menu();