<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'market_value_transition',
	'database_column_primary_key' => 'market_value_transition_id',

	//Menu
	'url_slug' => 'market-value-transitions',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Market Value Transition', $this->shared->get('text_domain')),
	'label_plural' => __('Market Value Transitions', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Market Value Transition', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Market Value Transition', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Market Value Transition', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Market Value Transition', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The market value transition has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The market value transition has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The market value transition has been successfully updated.', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'market_value_transition_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the market value transition.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'player_id',
			'label' => __('Player', $this->shared->get('text_domain')),
			'tooltip' => __('The player.', $this->shared->get('text_domain')),
			'filter' => 'get_player_name'
		],
		[
			'database_column' => 'date',
			'label' => __('Date', $this->shared->get('text_domain')),
			'tooltip' => __('The date of the market value transition.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
		[
			'database_column' => 'value',
			'label' => __('Value', $this->shared->get('text_domain')),
			'tooltip' => __('The value of the player.', $this->shared->get('text_domain')),
			'filter' => 'money_format'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'player_id',
			'query_placeholder_token' => 'd',
			'label' => __('Player', $this->shared->get('text_domain')),
			'tooltip' => __('The player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_players(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'player_exists',
					'message' => esc_attr__('Please enter a valid value in the "Player" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'date',
			'query_placeholder_token' => 's',
			'label' => __('Date', $this->shared->get('text_domain')),
			'tooltip' => __('The date of the market value transition.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => __('Please enter a valid value in the "Date" field.'),
				],
			],
			'required' => true,
			'searchable' => false,
		],
		[
			'column' => 'value',
			'query_placeholder_token' => 's',
			'label' => __('Value', $this->shared->get('text_domain')),
			'tooltip' => __('The value of the player.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_decimal_15_2',
					'message' => esc_attr__('Please enter a valid value in the "Value" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $menu_utility->num_of_players() === 0,
			'code' => 'num_of_players'
		],
	],

);
$menu->generate_menu();