<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'match',
	'database_column_primary_key' => 'match_id',

	//Menu
	'url_slug' => 'matches',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Match', $this->shared->get('text_domain')),
	'label_plural' => __('Matches', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create Match', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Match', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Match', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Match', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The match has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The match has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The match has been successfully updated.', $this->shared->get('text_domain')),
	'custom_validation' => 'menu_matches_custom_validation',

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'match_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the match.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'name',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the match.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'team_id_1',
			'label' => __('Team 1', $this->shared->get('text_domain')),
			'tooltip' => __('The team 1 of the match.', $this->shared->get('text_domain')),
			'filter' => 'get_team_name'
		],
		[
			'database_column' => 'team_id_2',
			'label' => __('Team 2', $this->shared->get('text_domain')),
			'tooltip' => __('The team 2 of the match.', $this->shared->get('text_domain')),
			'filter' => 'get_team_name'
		],
		[
			'database_column' => 'date',
			'label' => __('Date', $this->shared->get('text_domain')),
			'tooltip' => __('The date of the match.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
		[
			'database_column' => 'time',
			'label' => __('Time', $this->shared->get('text_domain')),
			'tooltip' => __('The time of the match.', $this->shared->get('text_domain')),
			'filter' => 'format_time'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'name',
			'query_placeholder_token' => 's',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the match.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => __('Please enter a valid value in the "Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'description',
			'query_placeholder_token' => 's',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the team.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => __('Please enter a valid value in the "Description" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'competition_id',
			'query_placeholder_token' => 'd',
			'label' => __('Competition', $this->shared->get('text_domain')),
			'tooltip' => __('The competition of the match.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_competitions(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'competition_exists_none_allowed',
					'message' => __('Please enter a valid value in the "Competition" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'round',
			'query_placeholder_token' => 'd',
			'label' => __('Round', $this->shared->get('text_domain')),
			'tooltip' => __('The round of the competition.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => [
				[
					'value' => 1,
					'text' => '1',
					'selected' => true
				],
				[
					'value' => 2,
					'text' => '2',
					'selected' => false
				],
				[
					'value' => 3,
					'text' => '3',
					'selected' => false
				],
				[
					'value' => 4,
					'text' => '4',
					'selected' => false
				],
			],
			'validation_regex' => null,
			'maxlength' => '1',
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'type',
			'query_placeholder_token' => 'd',
			'label' => __('Type', $this->shared->get('text_domain')),
			'tooltip' => __('The type of round of the competition.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => [
				[
					'value' => 0,
					'text' => __('Single Leg', 'soccer-engine-lite'),
					'selected' => true
				],
				[
					'value' => 1,
					'text' => __('First Leg', 'soccer-engine-lite'),
					'selected' => false
				],
				[
					'value' => 2,
					'text' => __('Second Leg', 'soccer-engine-lite'),
					'selected' => false
				],
			],
			'validation_regex' => null,
			'maxlength' => '1',
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'team_id_1',
			'query_placeholder_token' => 'd',
			'label' => __('Team 1', $this->shared->get('text_domain')),
			'tooltip' => __('The team 1 of the match.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_teams(),
			'validation_regex' => null,
			'validation_function' => [
				[
					'function' => 'team_exists',
					'message' => __('Please enter a valid value in the "Team 1" field.', $this->shared->get('text_domain')),
				],
			],
			'maxlength' => '1',
			'searchable' => false,
		],
		[
			'column' => 'team_id_2',
			'query_placeholder_token' => 'd',
			'label' => __('Team 2', $this->shared->get('text_domain')),
			'tooltip' => __('The team 2 of the match.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_teams(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'team_exists',
					'message' => __('Please enter a valid value in the "Team 2" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'squad_id_1',
			'query_placeholder_token' => 'd',
			'label' => __('Import Squad 1', $this->shared->get('text_domain')),
			'tooltip' => __('Use this selector to import the lineup, the substitutes, the staff members and the advanced options of team 1 from a squad.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_squads(true),
			'validation_regex' => null,
			'searchable' => false,
			'unsaved' => true,
		],
		[
			'column' => 'squad_id_2',
			'query_placeholder_token' => 'd',
			'label' => __('Import Squad 2', $this->shared->get('text_domain')),
			'tooltip' => __('Use this selector to import the lineup, the substitutes, the staff members and the advanced options of team 2 from a squad.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_squads(true),
			'validation_regex' => null,
			'searchable' => false,
			'required' => false,
			'unsaved' => true,
		],
		[
			'column' => 'date',
			'query_placeholder_token' => 's',
			'label' => __('Date', $this->shared->get('text_domain')),
			'tooltip' => __('The date of the match.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => __('Please enter a valid value in the "Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
		[
			'column' => 'time',
			'query_placeholder_token' => 's',
			'label' => __('Time', $this->shared->get('text_domain')),
			'tooltip' => __('The time of the match in the HH:MM format. E.g. 9:30, 15:00, 20:45', $this->shared->get('text_domain')),
			'type' => 'time',
			'maxlength' => '5',
			'validation_function' => [
				[
					'function' => 'validate_time',
					'message' => __('Please enter a valid value in the "Time" field. E.g. 9:30, 15:00, 20:45', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
		[
			'target' => 'additional-information',
			'label' => __('Additional Information', $this->shared->get('text_domain')),
			'type' => 'group-trigger',
		],
		[
			'class' => 'additional-information',
			'column' => 'fh_additional_time',
			'query_placeholder_token' => 's',
			'label' => __('First Half Additional Time', $this->shared->get('text_domain')),
			'tooltip' => __('The additional time of the first half in minutes.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_tinyint_unsigned',
					'message' => __('Please enter a valid value in the "First Half Extra Time" field.', $this->shared->get('text_domain')),
				],
			],
			'value' => '0',
			'required' => true,
			'searchable' => true,
		],
		[
			'class' => 'additional-information',
			'column' => 'sh_additional_time',
			'query_placeholder_token' => 's',
			'label' => __('Second Half Additional Time', $this->shared->get('text_domain')),
			'tooltip' => __('The additional time of the second half in minutes.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_tinyint_unsigned',
					'message' => __('Please enter a valid value in the "Second Half Additional Time" field.', $this->shared->get('text_domain')),
				],
			],
			'value' => '0',
			'required' => true,
			'searchable' => true,
		],
		[
			'class' => 'additional-information',
			'column' => 'fh_extra_time_additional_time',
			'query_placeholder_token' => 's',
			'label' => __('First Half Extra Time Additional Time', $this->shared->get('text_domain')),
			'tooltip' => __('The additional time of the first half extra time in minutes.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_tinyint_unsigned',
					'message' => __('Please enter a valid value in the "First Half Extra Time Additional Time" field.', $this->shared->get('text_domain')),
				],
			],
			'value' => '0',
			'required' => true,
			'searchable' => true,
		],
		[
			'class' => 'additional-information',
			'column' => 'sh_extra_time_additional_time',
			'query_placeholder_token' => 's',
			'label' => __('Second Half Extra Time Additional Time', $this->shared->get('text_domain')),
			'tooltip' => __('The additional time of the second half extra time in minutes.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_tinyint_unsigned',
					'message' => __('Please enter a valid value in the "Second Half Extra Time Additional Time" field.', $this->shared->get('text_domain')),
				],
			],
			'value' => '0',
			'required' => true,
			'searchable' => true,
		],
		[
			'class' => 'additional-information',
			'column' => 'referee_id',
			'query_placeholder_token' => 'd',
			'label' => __('Referee', $this->shared->get('text_domain')),
			'tooltip' => __('The referee of the match.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_referees(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'referee_exists_none_allowed',
					'message' => __('Please enter a valid value in the "Referee" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'class' => 'additional-information',
			'column' => 'stadium_id',
			'query_placeholder_token' => 'd',
			'label' => __('Stadium', $this->shared->get('text_domain')),
			'tooltip' => __('The stadium of the match.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_stadiums(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'stadium_exists_none_allowed',
					'message' => __('Please enter a valid value in the "Stadium" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'class' => 'additional-information',
			'column' => 'attendance',
			'query_placeholder_token' => 's',
			'label' => __('Attendance', $this->shared->get('text_domain')),
			'tooltip' => __('The attendance of the match.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '10',
			'validation_function' => [
				[
					'function' => 'validate_attendance',
					'message' => __('Please enter a valid value in the "Attendance" field.', $this->shared->get('text_domain')),
				],
			],
			'value' => '0',
			'required' => false,
			'searchable' => true,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $menu_utility->num_of_teams() === 0,
			'code' => 'num_of_teams'
		],
	],

);

for($t=1;$t<=2;$t++){

	$menu->settings['fields'][] = [
		'target' => 'lineup-team-' . $t,
		'label' => __('Lineup Team', $this->shared->get('text_domain')) . ' ' . $t,
		'type' => 'group-trigger',
	];

	for($i=1;$i<=11;$i++){
		$menu->settings['fields'][] = [
			'class' => 'lineup-team-' . $t,
			'column' => 'team_' . $t . '_lineup_player_id_' . $i,
			'query_placeholder_token' => 'd',
			'label' => __('Player', $this->shared->get('text_domain')) . ' ' . $i,
			'tooltip' => __('The player', $this->shared->get('text_domain')) . ' ' . $i . ' ' . __('of team', $this->shared->get('text_domain')) . ' ' . $t . '.',
			'type' => 'select',
			'select_items' => $menu_utility->select_players(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => $this->shared->player_exists_none_allowed,
					'message' => esc_attr__('Please enter a valid value in the "Player ', $this->shared->get('text_domain')) . $i .
					             esc_attr__(' field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		];
	}

	$menu->settings['fields'][] = [
		'target' => 'substitutes-team-' . $t,
		'label' => __('Substitutes Team', $this->shared->get('text_domain')) . ' ' . $t,
		'type' => 'group-trigger',
	];

	for($i=1;$i<=20;$i++){
		$menu->settings['fields'][] = [
			'class' => 'substitutes-team-' . $t,
			'column' => 'team_' . $t . '_substitute_player_id_' . $i,
			'query_placeholder_token' => 'd',
			'label' => __('Substitute', $this->shared->get('text_domain')) . ' ' . $i,
			'tooltip' => __('The substitute', $this->shared->get('text_domain')) . ' ' . $i . ' ' . __('of team', $this->shared->get('text_domain')) . ' ' . $t . '.',
			'type' => 'select',
			'select_items' => $menu_utility->select_players(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => $this->shared->player_exists_none_allowed,
					'message' => esc_attr__('Please enter a valid value in the "Substitute', $this->shared->get('text_domain')) . ' ' . $i .
					             esc_attr__(' field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		];
	}

	$menu->settings['fields'][] = [
		'target' => 'staff-team-' . $t,
		'label' => __('Staff Team', $this->shared->get('text_domain')) . ' ' . $t,
		'type' => 'group-trigger',
	];

	for($i=1;$i<=20;$i++){
		$menu->settings['fields'][] = [
			'class' => 'staff-team-' . $t,
			'column' => 'team_' . $t . '_staff_id_' . $i,
			'query_placeholder_token' => 'd',
			'label' => __('Staff', $this->shared->get('text_domain')) . ' ' . $i,
			'tooltip' => __('The staff', $this->shared->get('text_domain')) . ' ' . $i . ' ' . __('of team', $this->shared->get('text_domain')) . ' ' . $t . '.',
			'type' => 'select',
			'select_items' => $menu_utility->select_staff(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => $this->shared->staff_exists_none_allowed,
					'message' => esc_attr__('Please enter a valid value in the "Staff', $this->shared->get('text_domain')) . ' ' . $i .
					             esc_attr__(' field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		];
	}

	$menu->settings['fields'][] = [
		'target' => 'advanced-team-' . $t,
		'label' => __('Advanced Team', $this->shared->get('text_domain')) . ' ' . $t,
		'type' => 'group-trigger',
	];

	$menu->settings['fields'][] = [
		'class' => 'advanced-team-' . $t,
		'column' => 'team_' . $t . '_formation_id',
		'query_placeholder_token' => 'd',
		'label' => __('Formation', $this->shared->get('text_domain')),
		'tooltip' => __('The formation', $this->shared->get('text_domain')) . ' ' . __('of team', $this->shared->get('text_domain')) . ' ' . $t . '.',
		'type' => 'select',
		'select_items' => $menu_utility->select_formations(true),
		'validation_regex' => null,
		'maxlength' => '1',
		'validation_function' => [
			[
				'function' => 'formation_exists_none_allowed',
				'message' => __('Please enter a valid value in the "Formation" field.', $this->shared->get('text_domain')),
			],
		],
		'required' => false,
		'searchable' => false,
	];

	$menu->settings['fields'][] = [
		'class' => 'advanced-team-' . $t,
		'column' => 'team_' . $t . '_jersey_set_id',
		'query_placeholder_token' => 'd',
		'label' => __('Jersey Set', $this->shared->get('text_domain')),
		'tooltip' => __('The jersey set', $this->shared->get('text_domain')) . ' ' . __('of team', $this->shared->get('text_domain')) . ' ' . $t . '.',
		'type' => 'select',
		'select_items' => $menu_utility->select_jersey_sets(true),
		'validation_regex' => null,
		'maxlength' => '1',
		'validation_function' => [
			[
				'function' => 'jersey_set_exists_none_allowed',
				'message' => esc_attr__('Please enter a valid value in the "Jersey Set" field.', $this->shared->get('text_domain')),
			],
		],
		'required' => false,
		'searchable' => false,
	];

}





$menu->generate_menu();