<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'player_award',
	'database_column_primary_key' => 'player_award_id',

	//Menu
	'url_slug' => 'player-awards',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Player Award', $this->shared->get('text_domain')),
	'label_plural' => __('Player Awards', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Player Award', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Player Award', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Player Award', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Player Award', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The player award has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The player award has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The player award has been successfully updated.', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'player_award_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the player award.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'player_id',
			'label' => __('Player', $this->shared->get('text_domain')),
			'tooltip' => __('The player.', $this->shared->get('text_domain')),
			'filter' => 'get_player_name'
		],
		[
			'database_column' => 'player_award_type_id',
			'label' => __('Player Award Type', $this->shared->get('text_domain')),
			'tooltip' => __('The player award type.', $this->shared->get('text_domain')),
			'filter' => 'get_player_award_type_name'
		],
		[
			'database_column' => 'assignment_date',
			'label' => __('Assignment Date', $this->shared->get('text_domain')),
			'tooltip' => __('The assignment date of the player award.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'player_id',
			'query_placeholder_token' => 'd',
			'label' => __('Player', $this->shared->get('text_domain')),
			'tooltip' => __('The player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_players(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'player_exists',
					'message' => esc_attr__('Please enter a valid value in the "Player" field.', $this->shared->get('text_domain')),
				],
			],
			'searchable' => false,
		],
		[
			'column' => 'player_award_type_id',
			'query_placeholder_token' => 'd',
			'label' => __('Player Award Type', $this->shared->get('text_domain')),
			'tooltip' => __('The player award type.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_player_award_types(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'player_award_type_exists',
					'message' => esc_attr__('Please enter a valid value in the "Player Award Type" field.', $this->shared->get('text_domain')),
				],
			],
			'searchable' => false,
		],
		[
			'column' => 'assignment_date',
			'query_placeholder_token' => 's',
			'label' => __('Assignment Date', $this->shared->get('text_domain')),
			'tooltip' => __('The assignment date of the player award.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => esc_attr__('Please enter a valid value in the "Assignment Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $menu_utility->num_of_player_award_types() === 0,
			'code' => 'num_of_player_award_types'
		],
		[
			'status' => $menu_utility->num_of_players() === 0,
			'code' => 'num_of_players'
		]
	],

);
$menu->generate_menu();