<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'player',
	'database_column_primary_key' => 'player_id',

	//Menu
	'url_slug' => 'players',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Players', $this->shared->get('text_domain')),
	'label_plural' => __('Players', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Player', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Player', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Player', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Player', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The player has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The player has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The player has been successfully updated.', $this->shared->get('text_domain')),
	'custom_validation' => 'menu_players_custom_validation',

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'player_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the player.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'first_name',
			'label' => __('First Name', $this->shared->get('text_domain')),
			'tooltip' => __('The first name of the player.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'last_name',
			'label' => __('Last Name', $this->shared->get('text_domain')),
			'tooltip' => __('The last name of the player.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'player_position_id',
			'label' => __('Player Position', $this->shared->get('text_domain')),
			'tooltip' => __('The position of the player.', $this->shared->get('text_domain')),
			'filter' => 'get_player_position_name'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'first_name',
			'query_placeholder_token' => 's',
			'label' => __('First Name', $this->shared->get('text_domain')),
			'tooltip' => __('The first name of the player.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => esc_attr__('Please enter a valid value in the "First Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'last_name',
			'query_placeholder_token' => 's',
			'label' => __('Last Name', $this->shared->get('text_domain')),
			'tooltip' => __('The last name of the player.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => __('Please enter a valid value in the "Last Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'image',
			'query_placeholder_token' => 's',
			'label' => __('Image', $this->shared->get('text_domain')),
			'instructions' => __('Select an image that represents this player.', $this->shared->get('text_domain')),
			'set_image' => __('Set Image', $this->shared->get('text_domain')),
			'remove_image' => __('Remove Image', $this->shared->get('text_domain')),
			'type' => 'image',
			'maxlength' => '2083',
			'validation_function' => [
				[
					'function' => 'validate_url_empty_allowed',
					'message' => __('Please enter a valid value in the "Image" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'gender',
			'query_placeholder_token' => 'd',
			'label' => __('Gender', $this->shared->get('text_domain')),
			'tooltip' => __('The gender of the player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => [
				[
					'value' => 0,
					'text' => __('Male', 'soccer-engine-lite'),
					'selected' => True
				],
				[
					'value' => 1,
					'text' => __('Female', 'soccer-engine-lite'),
					'selected' => false
				]
			],
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_bool',
					'message' => esc_attr__('Please enter a valid date in the "Date of Death" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'date_of_birth',
			'query_placeholder_token' => 's',
			'label' => __('Date of Birth', $this->shared->get('text_domain')),
			'tooltip' => __('The date of birth of the player.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date_empty_allowed',
					'message' => esc_attr__('Please enter a valid date in the "Date of Birth" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'date_of_death',
			'query_placeholder_token' => 's',
			'label' => __('Date of Death', $this->shared->get('text_domain')),
			'tooltip' => __('The date of death of the player.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date_empty_allowed',
					'message' => esc_attr__('Please enter a valid date in the "Date of Death" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'citizenship',
			'query_placeholder_token' => 's',
			'label' => __('Citizenship', $this->shared->get('text_domain')),
			'tooltip' => __('The citizenship of the player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_countries(false),
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_country',
					'message' => esc_attr__('Please enter a valid value in the "Citizenship" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'second_citizenship',
			'query_placeholder_token' => 's',
			'label' => __('Second Citizenship', $this->shared->get('text_domain')),
			'tooltip' => __('The second citizenship of the player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_countries(true),
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_country_none_allowed',
					'message' => esc_attr__('Please enter a valid value in the "Second Citizenship" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'retired',
			'query_placeholder_token' => 'd',
			'label' => __('Retired', $this->shared->get('text_domain')),
			'tooltip' => __('The retired status of the player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => [
				[
					'value' => 0,
					'text' => 'No',
					'selected' => true
				],
				[
					'value' => 1,
					'text' => 'Yes',
					'selected' => false
				]
			],
			'validation_function' => [
				[
					'function' => 'validate_bool',
					'message' => esc_attr__('Please enter a valid value in the "Retired" field.', $this->shared->get('text_domain')),
				],
			],
			'maxlength' => '1',
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'player_position_id',
			'query_placeholder_token' => 'd',
			'label' => __('Player Position', $this->shared->get('text_domain')),
			'tooltip' => __('The position of the player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_player_positions(true),
			'validation_function' => [
				[
					'function' => 'validate_player_position_not_available_allowed',
					'message' => esc_attr__('Please enter a valid value in the "Player Position" field.', $this->shared->get('text_domain')),
				],
			],
			'maxlength' => '1',
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'foot',
			'query_placeholder_token' => 'd',
			'label' => __('Foot', $this->shared->get('text_domain')),
			'tooltip' => __('The foot of the player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_foot(),
			'validation_function' => [
				[
					'function' => 'validate_player_foot',
					'message' => esc_attr__('Please enter a valid value in the "Foot" field.', $this->shared->get('text_domain')),
				],
			],
			'maxlength' => '1',
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'height',
			'query_placeholder_token' => 's',
			'label' => __('Height', $this->shared->get('text_domain')),
			'tooltip' => __('The height of the player.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '3',
			'validation_function' => [
				[
					'function' => 'validate_player_height',
					'message' => esc_attr__('Please enter a valid date in the "Height" field.', $this->shared->get('text_domain')),
				],
			],
			'value' => '0',
			'required' => false,
			'searchable' => false,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $menu_utility->num_of_player_positions() === 0,
			'code' => 'num_of_player_positions'
		],
	],

);
$menu->generate_menu();