<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'ranking_transition',
	'database_column_primary_key' => 'ranking_transition_id',

	//Menu
	'url_slug' => 'ranking-transitions',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Ranking Transition', $this->shared->get('text_domain')),
	'label_plural' => __('Ranking Transitions', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Ranking Transition', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Ranking Transition', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Ranking Transition', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Ranking Transition', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The ranking transition has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The ranking transition has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The ranking transition has been successfully updated.', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'ranking_transition_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the ranking transition.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'team_id',
			'label' => __('Team', $this->shared->get('text_domain')),
			'tooltip' => __('The team of the ranking transition.', $this->shared->get('text_domain')),
			'filter' => 'get_team_name'
		],
		[
			'database_column' => 'ranking_type_id',
			'label' => __('Ranking Type', $this->shared->get('text_domain')),
			'tooltip' => __('The ranking type.', $this->shared->get('text_domain')),
			'filter' => 'get_ranking_type_name'
		],
		[
			'database_column' => 'date',
			'label' => __('Date', $this->shared->get('text_domain')),
			'tooltip' => __('The date of the ranking transition.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
		[
			'database_column' => 'value',
			'label' => __('Value', $this->shared->get('text_domain')),
			'tooltip' => __('The ranking value.', $this->shared->get('text_domain')),
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'team_id',
			'query_placeholder_token' => 'd',
			'label' => __('Team', $this->shared->get('text_domain')),
			'tooltip' => __('The team of the ranking transition.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_teams(),
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'team_exists',
					'message' => __('Please enter a valid value in the "Team" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'ranking_type_id',
			'query_placeholder_token' => 'd',
			'label' => __('Ranking Type', $this->shared->get('text_domain')),
			'tooltip' => __('The ranking type.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_ranking_types(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'ranking_type_exists',
					'message' => __('Please enter a valid value in the "Ranking Type" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'date',
			'query_placeholder_token' => 's',
			'label' => __('Date', $this->shared->get('text_domain')),
			'tooltip' => __('The date of the ranking transition.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => __('Please enter a valid value in the "Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
		[
			'column' => 'value',
			'query_placeholder_token' => 'd',
			'label' => __('Value', $this->shared->get('text_domain')),
			'tooltip' => __('The ranking value.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_int_unsigned',
					'message' => __('Please enter a valid value in the "Value" field.', $this->shared->get('text_domain')),
				],
			],
			'value' => '1',
			'required' => true,
			'searchable' => true,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $menu_utility->num_of_ranking_types() === 0,
			'code' => 'num_of_ranking_types'
		],
		[
			'status' => $menu_utility->num_of_teams() === 0,
			'code' => 'num_of_teams'
		]
	],

);
$menu->generate_menu();