<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'referee_badge',
	'database_column_primary_key' => 'referee_badge_id',

	//Menu
	'url_slug' => 'referee-badges',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Referee Badge', $this->shared->get('text_domain')),
	'label_plural' => __('Referee Badges', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Referee Badge', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Referee Badge', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Referee Badge', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Referee Badge', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The referee badge has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The referee badge has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The referee badge has been successfully updated.', $this->shared->get('text_domain')),
	'custom_validation' => 'menu_referee_badges_custom_validation',

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'referee_badge_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the referee badge.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'referee_id',
			'label' => __('Referee', $this->shared->get('text_domain')),
			'tooltip' => __('The referee.', $this->shared->get('text_domain')),
			'filter' => 'get_referee_name'
		],
		[
			'database_column' => 'referee_badge_type_id',
			'label' => __('Referee Badge Type', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the referee badge type.', $this->shared->get('text_domain')),
			'filter' => 'get_referee_badge_type_name'
		],
		[
			'database_column' => 'start_date',
			'label' => __('Start Date', $this->shared->get('text_domain')),
			'tooltip' => __('The start date of the referee badge.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
		[
			'database_column' => 'end_date',
			'label' => __('End Date', $this->shared->get('text_domain')),
			'tooltip' => __('The end date of the referee badge.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'referee_id',
			'query_placeholder_token' => 'd',
			'label' => __('Referee', $this->shared->get('text_domain')),
			'tooltip' => __('The referee.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_referees(),
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'referee_exists',
					'message' => __('Please enter a valid value in the "Referee" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'referee_badge_type_id',
			'query_placeholder_token' => 'd',
			'label' => __('Referee Badge Type', $this->shared->get('text_domain')),
			'tooltip' => __('The referee badge type.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_referee_badge_types(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'referee_badge_type_exists',
					'message' => __('Please enter a valid value in the "Referee Badge Type" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'start_date',
			'query_placeholder_token' => 's',
			'label' => __('Start Date', $this->shared->get('text_domain')),
			'tooltip' => __('The start date.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => __('Please enter a valid value in the "Start Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
		[
			'column' => 'end_date',
			'query_placeholder_token' => 's',
			'label' => __('End Date', $this->shared->get('text_domain')),
			'tooltip' => __('The end date.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => __('Please enter a valid value in the "End Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $menu_utility->num_of_referees() === 0,
			'code' => 'num_of_referees'
		],
		[
			'status' => $menu_utility->num_of_referee_badge_types() === 0,
			'code' => 'num_of_referee_badge_types'
		],
	],

);
$menu->generate_menu();