<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'referee',
	'database_column_primary_key' => 'referee_id',

	//Menu
	'url_slug' => 'referees',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Referee', $this->shared->get('text_domain')),
	'label_plural' => __('Referees', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Referee', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Referee', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Referee', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Referee', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The referee has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The referee has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The referee has been successfully updated.', $this->shared->get('text_domain')),
	'custom_validation' => 'menu_referees_custom_validation',

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'referee_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the referee.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'first_name',
			'label' => __('First Name', $this->shared->get('text_domain')),
			'tooltip' => __('The first name of the referee.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'last_name',
			'label' => __('Last Name', $this->shared->get('text_domain')),
			'tooltip' => __('The last name of the referee.', $this->shared->get('text_domain')),
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'first_name',
			'query_placeholder_token' => 's',
			'label' => __('First Name', $this->shared->get('text_domain')),
			'tooltip' => __('The first name of the referee.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => esc_attr__('Please enter a valid value in the "Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'last_name',
			'query_placeholder_token' => 's',
			'label' => __('Last Name', $this->shared->get('text_domain')),
			'tooltip' => __('The last name of the referee.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => esc_attr__('Please enter a valid value in the "Description" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'image',
			'query_placeholder_token' => 's',
			'label' => __('Image', $this->shared->get('text_domain')),
			'instructions' => __('Select an image that represents this referee.', $this->shared->get('text_domain')),
			'set_image' => __('Set Image', $this->shared->get('text_domain')),
			'remove_image' => __('Remove Image', $this->shared->get('text_domain')),
			'type' => 'image',
			'maxlength' => '2083',
			'validation_function' => [
				[
					'function' => 'validate_url_empty_allowed',
					'message' => __('Please enter a valid value in the "Image" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'gender',
			'query_placeholder_token' => 'd',
			'label' => __('Gender', $this->shared->get('text_domain')),
			'tooltip' => __('The gender of the referee.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => [
				[
					'value' => 0,
					'text' => __('Male', 'soccer-engine-lite'),
					'selected' => True
				],
				[
					'value' => 1,
					'text' => __('Female', 'soccer-engine-lite'),
					'selected' => false
				]
			],
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_bool',
					'message' => esc_attr__('Please enter a valid value in the "Gender" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'date_of_birth',
			'query_placeholder_token' => 's',
			'label' => __('Date of Birth', $this->shared->get('text_domain')),
			'tooltip' => __('The date of birth of the referee.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date_empty_allowed',
					'message' => esc_attr__('Please enter a valid value in the "Date of Birth" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'date_of_death',
			'query_placeholder_token' => 's',
			'label' => __('Date of Death', $this->shared->get('text_domain')),
			'tooltip' => __('The date of death of the referee.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date_empty_allowed',
					'message' => esc_attr__('Please enter a valid value in the "Date of Death" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'citizenship',
			'query_placeholder_token' => 's',
			'label' => __('Citizenship', $this->shared->get('text_domain')),
			'tooltip' => __('The citizenship of the referee.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_countries(false),
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_country',
					'message' => esc_attr__('Please enter a valid value in the "Citizenship" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'second_citizenship',
			'query_placeholder_token' => 's',
			'label' => __('Second citizenship', $this->shared->get('text_domain')),
			'tooltip' => __('The second citizenship of the referee.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_countries(true),
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_country_none_allowed',
					'message' => esc_attr__('Please enter a valid value in the "Second Citizenship" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'retired',
			'query_placeholder_token' => 'd',
			'label' => __('Retired', $this->shared->get('text_domain')),
			'tooltip' => __('The retired status of the referee.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => [
				[
					'value' => 0,
					'text' => __('No', 'soccer-engine-lite'),
					'selected' => true
				],
				[
					'value' => 1,
					'text' => __('Yes', 'soccer-engine-lite'),
					'selected' => false
				]
			],
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_bool',
					'message' => esc_attr__('Please enter a valid value in the "Status" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'place_of_birth',
			'query_placeholder_token' => 's',
			'label' => __('Place of Birth', $this->shared->get('text_domain')),
			'tooltip' => __('The place of birth of the referee.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Place of Birth" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'residence',
			'query_placeholder_token' => 's',
			'label' => __('Residence', $this->shared->get('text_domain')),
			'tooltip' => __('The residence of the referee.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Residence" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'job',
			'query_placeholder_token' => 's',
			'label' => __('Job', $this->shared->get('text_domain')),
			'tooltip' => __('The job of the referee.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Job" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
	],
);
$menu->generate_menu();