<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'squad',
	'database_column_primary_key' => 'squad_id',

	//Menu
	'url_slug' => 'squads',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Squad', $this->shared->get('text_domain')),
	'label_plural' => __('Squads', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create Squad', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Squad', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Squad', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Squad', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The squad has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The squad has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The squad has been successfully updated.', $this->shared->get('text_domain')),
	'custom_validation' => 'menu_squads_custom_validation',

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'squad_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the squad.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'name',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the squad.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'description',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the jersey set.', $this->shared->get('text_domain')),
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'name',
			'query_placeholder_token' => 's',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the squad.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => esc_attr__('Please enter a valid value in the "Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'description',
			'query_placeholder_token' => 's',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the squad.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => esc_attr__('Please enter a valid value in the "Description" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
	],

);

$menu->settings['fields'][] = [
	'target' => 'lineup',
	'label' => __('Lineup', $this->shared->get('text_domain')),
	'type' => 'group-trigger',
];

for($i=1;$i<=11;$i++){
	$menu->settings['fields'][] = [
		'class' => 'lineup',
		'column' => 'lineup_player_id_' . $i,
		'query_placeholder_token' => 'd',
		'label' => __('Player', $this->shared->get('text_domain')) . ' ' . $i,
		'tooltip' => __('The player', $this->shared->get('text_domain')) . ' ' . $i . ' ' . __('of the squad.', $this->shared->get('text_domain')),
		'type' => 'select',
		'select_items' => $menu_utility->select_players(true),
		'validation_regex' => null,
		'maxlength' => '1',
		'validation_function' => [
			[
				'function' => $this->shared->player_exists_none_allowed,
				'message' => esc_attr__('Please enter a valid value in the "Player ', $this->shared->get('text_domain')) . $i .
                esc_attr__(' field.', $this->shared->get('text_domain')),
			],
		],
		'required' => false,
		'searchable' => false,
	];
}

$menu->settings['fields'][] = [
	'target' => 'substitutes',
	'label' => __('Substitutes', $this->shared->get('text_domain')),
	'type' => 'group-trigger',
];

for($i=1;$i<=20;$i++){
	$menu->settings['fields'][] = [
		'class' => 'substitutes',
		'column' => 'substitute_player_id_' . $i,
		'query_placeholder_token' => 'd',
		'label' => __('Substitute', $this->shared->get('text_domain')) . ' ' . $i,
		'tooltip' => __('The substitute', $this->shared->get('text_domain')) . ' ' . $i . ' ' . __('of the squad.', $this->shared->get('text_domain')),
		'type' => 'select',
		'select_items' => $menu_utility->select_players(true),
		'validation_regex' => null,
		'maxlength' => '1',
		'validation_function' => [
			[
				'function' => $this->shared->player_exists_none_allowed,
				'message' => esc_attr__('Please enter a valid value in the "Substitutes', $this->shared->get('text_domain')) . ' ' . $i .
				             esc_attr__(' field.', $this->shared->get('text_domain')),
			],
		],
		'required' => false,
		'searchable' => false,
	];
}

$menu->settings['fields'][] = [
	'target' => 'staff',
	'label' => __('Staff', $this->shared->get('text_domain')),
	'type' => 'group-trigger',
];

for($i=1;$i<=20;$i++){
	$menu->settings['fields'][] = [
		'class' => 'staff',
		'column' => 'staff_id_' . $i,
		'query_placeholder_token' => 'd',
		'label' => __('Staff', $this->shared->get('text_domain')) . ' ' . $i,
		'tooltip' => __('The staff member', $this->shared->get('text_domain')) . ' ' . $i . '.',
		'type' => 'select',
		'select_items' => $menu_utility->select_staff(true),
		'validation_regex' => null,
		'maxlength' => '1',
		'validation_function' => [
			[
				'function' => $this->shared->staff_exists_none_allowed,
				'message' => esc_attr__('Please enter a valid value in the "Staff', $this->shared->get('text_domain')) . ' ' . $i .
				             esc_attr__(' field.', $this->shared->get('text_domain')),
			],
		],
		'required' => false,
		'searchable' => false,
	];
}

$menu->settings['fields'][] = [
	'target' => 'advanced',
	'label' => __('Advanced', $this->shared->get('text_domain')),
	'type' => 'group-trigger',
];

$menu->settings['fields'][] = [
	'class' => 'advanced',
	'column' => 'formation_id',
	'query_placeholder_token' => 'd',
	'label' => __('Formation', $this->shared->get('text_domain')),
	'tooltip' => __('The formation', $this->shared->get('text_domain')),
	'type' => 'select',
	'select_items' => $menu_utility->select_formations(true),
	'validation_regex' => null,
	'maxlength' => '1',
	'validation_function' => [
		[
			'function' => 'formation_exists_none_allowed',
			'message' => __('Please enter a valid value in the "Formation" field.', $this->shared->get('text_domain')),
		],
	],
	'required' => false,
	'searchable' => false,
];

$menu->settings['fields'][] = [
	'class' => 'advanced',
	'column' => 'jersey_set_id',
	'query_placeholder_token' => 'd',
	'label' => __('Jersey Set', $this->shared->get('text_domain')),
	'tooltip' => __('The jersey set.', $this->shared->get('text_domain')),
	'type' => 'select',
	'select_items' => $menu_utility->select_jersey_sets(true),
	'validation_regex' => null,
	'maxlength' => '1',
	'validation_function' => [
		[
			'function' => 'jersey_set_exists_none_allowed',
			'message' => esc_attr__('Please enter a valid value in the "Jersey Set" field.', $this->shared->get('text_domain')),
		],
	],
	'required' => false,
	'searchable' => false,
];

$menu->generate_menu();