<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'staff_award',
	'database_column_primary_key' => 'staff_award_id',

	//Menu
	'url_slug' => 'staff-awards',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Staff Award', $this->shared->get('text_domain')),
	'label_plural' => __('Staff Awards', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Staff Award', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Staff Award', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Staff Award', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Staff Award', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The staff award has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The staff award has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The staff award has been successfully updated.', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'staff_award_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the staff award.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'staff_id',
			'label' => __('Staff', $this->shared->get('text_domain')),
			'tooltip' => __('The staff name.', $this->shared->get('text_domain')),
			'filter' => 'get_staff_name'
		],
		[
			'database_column' => 'staff_award_type_id',
			'label' => __('Staff Award Type', $this->shared->get('text_domain')),
			'tooltip' => __('The staff award type.', $this->shared->get('text_domain')),
			'filter' => 'get_staff_award_type_name'
		],
		[
			'database_column' => 'assignment_date',
			'label' => __('Assignment Date', $this->shared->get('text_domain')),
			'tooltip' => __('The assignment date.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'staff_id',
			'query_placeholder_token' => 'd',
			'label' => __('Staff', $this->shared->get('text_domain')),
			'tooltip' => __('The staff member.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_staff(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'staff_exists',
					'message' => esc_attr__('Please enter a valid value in the "Staff Exists" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'staff_award_type_id',
			'query_placeholder_token' => 'd',
			'label' => __('Staff Award Type', $this->shared->get('text_domain')),
			'tooltip' => __('The staff award type.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_staff_award_types(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'staff_award_type_exists',
					'message' => esc_attr__('Please enter a valid value in the "Staff Award Type" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'assignment_date',
			'query_placeholder_token' => 's',
			'label' => __('Assignment Date', $this->shared->get('text_domain')),
			'tooltip' => __('The assignment date.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => esc_attr__('Please enter a valid value in the "Assignment Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $menu_utility->num_of_staff_award_types() === 0,
			'code' => 'num_of_staff_award_types'
		],
		[
			'status' => $menu_utility->num_of_staffs() === 0,
			'code' => 'num_of_staffs'
		]
	],

);
$menu->generate_menu();