<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'team',
	'database_column_primary_key' => 'team_id',

	//Menu
	'url_slug' => 'teams',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Team', $this->shared->get('text_domain')),
	'label_plural' => __('Teams', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create Team', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Team', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Team', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Team', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The team has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The team has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The team has been successfully updated.', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'team_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the team.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'name',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the team.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'type',
			'label' => __('Type', $this->shared->get('text_domain')),
			'tooltip' => __('The type of team.', $this->shared->get('text_domain')),
			'filter' => 'get_team_type_name'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'name',
			'query_placeholder_token' => 's',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the team.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => esc_attr__('Please enter a valid value in the "Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'description',
			'query_placeholder_token' => 's',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the team.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => esc_attr__('Please enter a valid value in the "Description" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'logo',
			'query_placeholder_token' => 's',
			'label' => __('Logo', $this->shared->get('text_domain')),
			'instructions' => __('Select a logo that represents this team.', $this->shared->get('text_domain')),
			'set_image' => __('Set Image', $this->shared->get('text_domain')),
			'remove_image' => __('Remove Image', $this->shared->get('text_domain')),
			'type' => 'image',
			'maxlength' => '2083',
			'validation_function' => [
				[
					'function' => 'validate_url_empty_allowed',
					'message' => esc_attr__('Please enter a valid value in the "Logo" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'type',
			'query_placeholder_token' => 'd',
			'label' => __('Type', $this->shared->get('text_domain')),
			'tooltip' => __('The type of team.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => [
				[
					'value' => 0,
					'text' => 'Club',
					'selected' => true
				],
				[
					'value' => 1,
					'text' => 'National Team',
					'selected' => false
				]
			],
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_bool',
					'message' => esc_attr__('Please enter a valid value in the "Type" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'club_nation',
			'query_placeholder_token' => 's',
			'label' => __('Club Nation', $this->shared->get('text_domain')),
			'tooltip' => __('The club nation.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_countries(),
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_country',
					'message' => esc_attr__('Please enter a valid value in the "Club Nation" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'national_team_confederation',
			'query_placeholder_token' => 'd',
			'label' => __('National Team Confederation', $this->shared->get('text_domain')),
			'tooltip' => __('The national team confederation.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_national_team_confederations(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_national_team_confederation',
					'message' => esc_attr__('Please enter a valid value in the "National Team Confederation" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'stadium_id',
			'query_placeholder_token' => 'd',
			'label' => __('Stadium', $this->shared->get('text_domain')),
			'tooltip' => __('The stadium of the team.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_stadiums(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'stadium_exists_none_allowed',
					'message' => esc_attr__('Please enter a valid value in the "Stadium" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'full_name',
			'query_placeholder_token' => 's',
			'label' => __('Full Name', $this->shared->get('text_domain')),
			'tooltip' => __('The full name of the team.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Full Name" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'address',
			'query_placeholder_token' => 's',
			'label' => __('Address', $this->shared->get('text_domain')),
			'tooltip' => __('The address of the team.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Address" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'tel',
			'query_placeholder_token' => 's',
			'label' => __('Tel', $this->shared->get('text_domain')),
			'tooltip' => __('The telephone number of the team.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Tel" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'fax',
			'query_placeholder_token' => 's',
			'label' => __('Fax', $this->shared->get('text_domain')),
			'tooltip' => __('The fax number of the team.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Fax" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'website_url',
			'query_placeholder_token' => 's',
			'label' => __('Website URL', $this->shared->get('text_domain')),
			'tooltip' => __('The website URL of the team.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_0_255',
					'message' => esc_attr__('Please enter a valid value in the "Website URL" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
		[
			'column' => 'foundation_date',
			'query_placeholder_token' => 's',
			'label' => __('Foundation Date', $this->shared->get('text_domain')),
			'tooltip' => __('The foundation date of the team.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date_empty_allowed',
					'message' => esc_attr__('Please enter a valid value in the "Foundation Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
	],

);
$menu->generate_menu();