<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'transfer',
	'database_column_primary_key' => 'transfer_id',

	//Menu
	'url_slug' => 'transfers',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Transfers', $this->shared->get('text_domain')),
	'label_plural' => __('Transfers', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Transfer', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Transfer', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Transfer', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Transfer', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The transfer has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The transfer has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The transfer has been successfully updated.', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'transfer_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the transfer.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'player_id',
			'label' => __('Player', $this->shared->get('text_domain')),
			'tooltip' => __('The player.', $this->shared->get('text_domain')),
			'filter' => 'get_player_name'
		],
		[
			'database_column' => 'transfer_type_id',
			'label' => __('Transfer Type', $this->shared->get('text_domain')),
			'tooltip' => __('The transfer type.', $this->shared->get('text_domain')),
			'filter' => 'get_transfer_type_name'
		],
		[
			'database_column' => 'team_id_left',
			'label' => __('Team Left', $this->shared->get('text_domain')),
			'tooltip' => __('The team left by the player.', $this->shared->get('text_domain')),
			'filter' => 'get_team_name'
		],
		[
			'database_column' => 'team_id_joined',
			'label' => __('Team Joined', $this->shared->get('text_domain')),
			'tooltip' => __('The team joined by the player.', $this->shared->get('text_domain')),
			'filter' => 'get_team_name'
		],
		[
			'database_column' => 'date',
			'label' => __('Date', $this->shared->get('text_domain')),
			'tooltip' => __('The date of the transfer.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
		[
			'database_column' => 'fee',
			'label' => __('Fee', $this->shared->get('text_domain')),
			'tooltip' => __('The transfer fee.', $this->shared->get('text_domain')),
			'filter' => 'money_format'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'player_id',
			'query_placeholder_token' => 'd',
			'label' => __('Player', $this->shared->get('text_domain')),
			'tooltip' => __('The player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_players(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'player_exists',
					'message' => esc_attr__('Please enter a valid value in the "Player" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'transfer_type_id',
			'query_placeholder_token' => 'd',
			'label' => __('Transfer Type', $this->shared->get('text_domain')),
			'tooltip' => __('The transfer type.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_transfer_types(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'transfer_type_exists',
					'message' => esc_attr__('Please enter a valid value in the "Transfer Type" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'team_id_left',
			'query_placeholder_token' => 'd',
			'label' => __('Team Left', $this->shared->get('text_domain')),
			'tooltip' => __('The team left by the player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_teams(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'team_exists_none_allowed',
					'message' => esc_attr__('Please enter a valid value in the "Team Left" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'team_id_joined',
			'query_placeholder_token' => 'd',
			'label' => __('Team Joined', $this->shared->get('text_domain')),
			'tooltip' => __('The team joined by the player.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_teams(true),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'team_exists_none_allowed',
					'message' => esc_attr__('Please enter a valid value in the "Team Joined" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'date',
			'query_placeholder_token' => 's',
			'label' => __('Date', $this->shared->get('text_domain')),
			'tooltip' => __('The date of the transfer.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => esc_attr__('Please enter a valid value in the "Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
		[
			'column' => 'fee',
			'query_placeholder_token' => 's',
			'label' => __('Fee', $this->shared->get('text_domain')),
			'tooltip' => __('The fee of the transfer.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_decimal_15_2',
					'message' => esc_attr__('Please enter a valid value in the "Fee" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $menu_utility->num_of_players() === 0,
			'code' => 'num_of_players'
		],
		[
			'status' => $menu_utility->num_of_teams() === 0,
			'code' => 'num_of_teams'
		],
		[
			'status' => $menu_utility->num_of_transfer_types() === 0,
			'code' => 'num_of_transfer_types'
		],
	],

);
$menu->generate_menu();