<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

	//Database
	'database_table_name' => 'trophy',
	'database_column_primary_key' => 'trophy_id',

	//Menu
	'url_slug' => 'trophies',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Trophy', $this->shared->get('text_domain')),
	'label_plural' => __('Trophies', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Trophy', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Trophy', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Trophy', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Trophy', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The trophy has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The trophy has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The trophy has been successfully updated.', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'trophy_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the trophy.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'trophy_type_id',
			'label' => __('Trophy Type', $this->shared->get('text_domain')),
			'tooltip' => __('The trophy type.', $this->shared->get('text_domain')),
			'filter' => 'get_trophy_type_name'
		],
		[
			'database_column' => 'team_id',
			'label' => __('Team', $this->shared->get('text_domain')),
			'tooltip' => __('The team.', $this->shared->get('text_domain')),
			'filter' => 'get_team_name'
		],
		[
			'database_column' => 'assignment_date',
			'label' => __('Assignment Date', $this->shared->get('text_domain')),
			'tooltip' => __('The assignment date.', $this->shared->get('text_domain')),
			'filter' => 'format_date_timestamp'
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'trophy_type_id',
			'query_placeholder_token' => 'd',
			'label' => __('Trophy Type', $this->shared->get('text_domain')),
			'tooltip' => __('The trophy type.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_trophy_types(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'trophy_type_exists',
					'message' => esc_attr__('Please enter a valid value in the "Trophy Type" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'team_id',
			'query_placeholder_token' => 'd',
			'label' => __('Team', $this->shared->get('text_domain')),
			'tooltip' => __('The team associated with the trophy.', $this->shared->get('text_domain')),
			'type' => 'select',
			'select_items' => $menu_utility->select_teams(),
			'validation_regex' => null,
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'team_exists',
					'message' => esc_attr__('Please enter a valid value in the "Team" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => false,
		],
		[
			'column' => 'assignment_date',
			'query_placeholder_token' => 's',
			'label' => __('Assignment Date', $this->shared->get('text_domain')),
			'tooltip' => __('The assignment date.', $this->shared->get('text_domain')),
			'type' => 'date',
			'maxlength' => '1',
			'validation_function' => [
				[
					'function' => 'validate_date',
					'message' => esc_attr__('Please enter a valid value in the "Assignment Date" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => false,
		],
	],

	//Blocking Conditions
	'blocking_conditions' => [
		[
			'status' => $menu_utility->num_of_trophy_types() === 0,
			'code' => 'num_of_trophy_types'
		],
		[
			'status' => $menu_utility->num_of_teams() === 0,
			'code' => 'num_of_teams'
		]
	],

);
$menu->generate_menu();