<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

    //Database
	'database_table_name' => 'trophy_type',
	'database_column_primary_key' => 'trophy_type_id',

	//Menu
	'url_slug' => 'trophy-types',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Trophy Type', $this->shared->get('text_domain')),
	'label_plural' => __('Trophy Types', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Trophy Type', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Trophy Type', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Trophy Type', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Trophy Type', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The trophy type has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The trophy type has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The trophy type has been successfully updated.', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'trophy_type_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the trophy type.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'name',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the trophy type.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'description',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the trophy type.', $this->shared->get('text_domain')),
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'name',
			'query_placeholder_token' => 's',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the trophy type.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => __('Please enter a valid value in the "Name" field.', $this->shared->get('text_domain')),
				],
			],
            'required' => true,
            'searchable' => true,
		],
		[
			'column' => 'description',
			'query_placeholder_token' => 's',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the trophy type.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => __('Please enter a valid value in the "Description" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
		[
			'column' => 'logo',
			'query_placeholder_token' => 's',
			'label' => __('Logo', $this->shared->get('text_domain')),
			'instructions' => __('Select a logo that represents this trophy.', $this->shared->get('text_domain')),
			'set_image' => __('Set Image', $this->shared->get('text_domain')),
			'remove_image' => __('Remove Image', $this->shared->get('text_domain')),
			'type' => 'image',
			'maxlength' => '2083',
			'validation_function' => [
				[
					'function' => 'validate_url_empty_allowed',
					'message' => __('Please enter a valid value in the "Logo" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => false,
			'searchable' => true,
		],
	],
);
$menu->generate_menu();