<?php

require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu.php');
$menu = new Daextsoenl_Menu($this->shared);
require_once($this->shared->get('dir') . '/admin/inc/class-daextsoenl-menu-utility.php');
$menu_utility = new Daextsoenl_Menu_Utility($this->shared);
$menu->settings = array(

    //Database
	'database_table_name' => 'unavailable_player_type',
	'database_column_primary_key' => 'unavailable_player_type_id',

	//Menu
	'url_slug' => 'unavailable-player-types',
	'enable_clone_button' => false,

	//Labels
	'plugin_name' => __('Soccer Engine', $this->shared->get('text_domain')),
	'label_singular' => __('Unavailable Player Type', $this->shared->get('text_domain')),
	'label_plural' => __('Unavailable Player Types', $this->shared->get('text_domain')),
	'label_create_new_item' => __('Create New Unavailable Player Type', $this->shared->get('text_domain')),
	'label_edit_item' => __('Edit Unavailable Player Type', $this->shared->get('text_domain')),
	'label_add_item' => __('Add Unavailable Player Type', $this->shared->get('text_domain')),
	'label_update_item' => __('Update Unavailable Player Type', $this->shared->get('text_domain')),
	'label_cancel_item' => __('Cancel', $this->shared->get('text_domain')),
	'label_perform_your_search' => __('Perform your Search', $this->shared->get('text_domain')),
	'label_no_results_match_filter' => __('There are no results that match your filter.', $this->shared->get('text_domain')),
	'label_item_deleted' => __('The unavailable player type has been successfully deleted.', $this->shared->get('text_domain')),
	'label_item_added' => __('The unavailable player type has been successfully added.', $this->shared->get('text_domain')),
	'label_item_updated' => __('The unavailable player type has been successfully updated', $this->shared->get('text_domain')),

	//Pagination Columns
	'pagination_columns' => [
		[
			'database_column' => 'unavailable_player_type_id',
			'label' => __('ID', $this->shared->get('text_domain')),
			'tooltip' => __('The ID of the unavailable player type.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'name',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the unavailable player type.', $this->shared->get('text_domain')),
		],
		[
			'database_column' => 'description',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the unavailable player type.', $this->shared->get('text_domain')),
		],
	],

	//Pagination Items
	'pagination_items' => 10,

	//Form Fields
	'fields' => [
		[
			'column' => 'name',
			'query_placeholder_token' => 's',
			'label' => __('Name', $this->shared->get('text_domain')),
			'tooltip' => __('The name of the unavailable player type.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => esc_attr__('Please enter a valid value in the "Name" field.', $this->shared->get('text_domain')),
				],
			],
            'required' => true,
            'searchable' => true,
		],
		[
			'column' => 'description',
			'query_placeholder_token' => 's',
			'label' => __('Description', $this->shared->get('text_domain')),
			'tooltip' => __('The description of the unavailable player type.', $this->shared->get('text_domain')),
			'type' => 'text',
			'maxlength' => '255',
			'validation_function' => [
				[
					'function' => 'validate_text_1_255',
					'message' => esc_attr__('Please enter a valid value in the "Description" field.', $this->shared->get('text_domain')),
				],
			],
			'required' => true,
			'searchable' => true,
		],
	],
);
$menu->generate_menu();